#Region Compiler directives section
;** This is a list of compiler directives used by CompileAU3.exe.
;** comment the lines you don't need or else it will override the default settings
#Compiler_Prompt=y              					;y=show compile menu
;** AUT2EXE settings
;#Compiler_AUT2EXE=
#Compiler_Icon=images\ClipSaver.ico               			;Filename of the Ico file to use
;#Compiler_OutFile=              					;Target exe filename.
#Compiler_Compression=4         					;Compression parameter 0-4  0=Low 2=normal 4=High
#Compiler_Allow_Decompile=n      					;y= allow decompile
;#Compiler_PassPhrase=           					;Password to use for compilation
;** Target program Resource info
#Compiler_Res_Comment=Paste clipboard directly to file. Append data to clipboard. Save url to file.
#Compiler_Res_Description=ClipSaver Browser/Clipboard helper tool.
#Compiler_Res_FileVersion_AutoIncrement=n
#Compiler_Res_Fileversion=1.0.0.7
#Compiler_Res_LegalCopyright=Steve Podhajecki (2006)
; free form resource fields ... max 15
#Compiler_Res_Field=Email|steve@ocotillo.sytes.net	;Free format fieldname|fieldvalue
#Compiler_Res_Field=Release Date|07/25/2006  		;Free format fieldname|fieldvalue
#Compiler_Res_Field=Internal Name|ClipSaver.exe 	;Free format fieldname|fieldvalue
#Compiler_Res_Field=Status|Beta 					;Free format fieldname|fieldvalue
#Compiler_Run_AU3Check=y        					;Run au3check before compilation
#Compiler_AU3Check_Dat= ;Override the default au3check definition
#Compiler_AU3Check_Parameters= -q -d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w 7 ;Au3Check parameters
;#Compiler_PlugIn_Funcs=
; The following directives can contain:
;   %in% , %out%, %icon% which will be replaced by the fullpath\filename.
;   %scriptdir% same as @ScriptDir and %scriptfile% = filename without extension.
#Compiler_Run_Before=           					;process to run before compilation - you can have multiple records that will be processed in sequence
#Compiler_Run_After=move "%out%" "%scriptdir%"  	;process to run After compilation - you can have multiple records that will be processed in sequence
#EndRegion
Local $sFile, $ret
#Include <GuiConstants.au3>
#include <Misc.au3>
#Include <Constants.au3>
#Include "include\Clipboard.au3"
#NoTrayIcon
;----------------------------------------------------------
; Constants
;----------------------------------------------------------
;~ Global Const $WM_NOTIFY = 0x004E
;~ Global Const $WM_CHANGECBCHAIN = 0x030D
;~ Global Const $WM_COPYDATA = 0x4A
;~ Global Const $WM_DRAWCLIPBOARD = 0x0308
Global Const $NULL = Chr(0)
;----------------------------------------------------------
; Variables
;----------------------------------------------------------
If Not IsDeclared("MULTIINSTANCE") Then
	Global $MULTIINSTANCE = 0
EndIf
;Global $hWnd_NEXT_IN_CLIP_CHAIN
Global $hWnd_ME
;Global $hWnd_PREV_IN_CLIP_CHAIN
;Global $bInChain = False
;Global $EVENT = 0
;Global $DEBUG = True
Global $bAUTO = True
Global $bAUTO_OLD = $NULL
Global $bAPPEND = False
Global $sAppendClip = ""
Global $TIMER = 0
Global $TIMEDIFF = 1000
Global $hWnd_ME_Child[10]

;----------------------------------------------------------
;Defalut save path and extentions
;----------------------------------------------------------
Global $DEFAULT_PATH = @ScriptDir & "\scripts"
Global $DEFAULT_EXT = "*.au3"
Global $DEFAULT_FILTER = "Autoit (*.au3)"
;----------------------------------------------------------

;----------------------------------------------------------
; Tray, Gui for Hooks
;----------------------------------------------------------
$hWnd_ME = GUICreate("ClipSaver", 546, 324, (@DesktopWidth - 545) / 2, (@DesktopHeight - 324) / 2, -1, $WS_EX_ACCEPTFILES);, 196, 124)
GUISetState(@SW_HIDE)
;----------------------------------------------------------
; Tray Menu Items
;----------------------------------------------------------
Global $TrayAbout, $TrayAppend, $TrayExit, $TrayPaused, $TraySave, $TrayUrlGet, $TrayClipClear
Opt("TrayMenuMode", 1)
$TrayPaused = TrayCreateItem("Automatic Mode")
TrayCreateItem("")
$TrayAppend = TrayCreateItem("Append Mode")
TrayCreateItem("")
$TraySave = TrayCreateItem("Save Clipboard")
$TrayUrlGet = TrayCreateItem("Save URL")
$TrayClipClear = TrayCreateItem("Clear Clipboard")
TrayCreateItem("")
$TrayAbout = TrayCreateItem("About")
TrayCreateItem("")
$TrayExit = TrayCreateItem("Exit")
TraySetState()
;----------------------------------------------------------
;Application
;----------------------------------------------------------
_InitAsClipViewer ($hWnd_ME) ; add this app as cliboard viewer
_GetSetAutomaticMode($TRAY_CHECKED)     ; Turn auto mode on
Main() ; Main msg/event handler
_StopAsClipViewer ($hWnd_ME) ; Remove this app as viewer, unhook msg
Exit

;----------------------------------------------------------
;Main msg/event loop
;----------------------------------------------------------
Func Main()
	Local $msg
	While 1
		$msg = TrayGetMsg()
		Select
			Case $msg = $TrayExit
				Exit
			Case $msg = $TrayClipClear
				ClipPut("")
				$sAppendClip = ""
			Case $msg = $TraySave
				;explicit save
				_SaveClipToFile()
			Case $msg = $TrayUrlGet
				;Clipboard is url get source and save it.
				_SaveClipUrlToFile()
			Case $msg = $TrayPaused
				If $bAUTO Then
					_GetSetAutomaticMode($TRAY_UNCHECKED)
				Else
					_GetSetAutomaticMode($TRAY_CHECKED)
				EndIf
			Case $msg = $TrayAppend
				If $bAPPEND Then
					_SetAppendMode($TRAY_UNCHECKED)
					;if Not ($bAUTO_OLD) then _GetSetAutomaticMode(1)
				Else
					_SetAppendMode($TRAY_CHECKED)
					;$bAUTO_OLD =$bAUTO
					;Turn off automatic mode
					;_GetSetAutomaticMode(0)
				EndIf
			Case $msg = $TrayAbout
				If _About() = 0 Then
					MsgBox(266288, "ClipSaver", "This program saves clipboard data to a file." & @LF & _
							"Copyright 2006, Stephen Podhajecki" & @LF)
				EndIf
			Case $EVENT = $WM_DRAWCLIPBOARD
				If $DEBUG Then ConsoleWrite("Event $WM_DRAWCLIPBOARD" & @LF)
				Select
					Case $bAPPEND
						_AppendToClip()
						ToolTip("Copy appended")
						$TIMER = TimerInit()
					Case ($bAUTO)
						;get the active window
						Local $sWinText = _GetActiveWindowTitle($hWnd_ME)
						;does it match a browser? What does opera put in title bar?
						If StringInStr($sWinText, "Mozilla Firefox") Or StringInStr($sWinText, "Internet Explorer") Then
							;Matches browser try to save clip.
							_SaveClipToFile()
						EndIf
					Case Else
						;
				EndSelect
				
			Case $EVENT = $WM_CHANGECBCHAIN
				If $DEBUG Then ConsoleWrite("Event $WM__CHANGECBCHAIN" & @LF)
		EndSelect
		$EVENT = 0
		If $TIMER > 0 Then
			If TimerDiff($TIMER) > $TIMEDIFF Then
				$TIMER = 0
				ToolTip("")
			EndIf
		EndIf
	WEnd
EndFunc   ;==>Main

;----------------------------------------------------------
;First Function called. Check for another instance.
;----------------------------------------------------------
Func OnAutoItStart()
	If Not IsDeclared("MULTIINSTANCE") Then	Global $MULTIINSTANCE = 0
	If _Singleton("ClipSaver\ClipSaver", 1) = 0 Then
		MsgBox(0, "Warning", "An occurence of ClipSaver is already running.")
		$MULTIINSTANCE = 1
		Exit
	EndIf
EndFunc   ;==>OnAutoItStart

;----------------------------------------------------------
;Last Function called. Clean up.
;----------------------------------------------------------
Func OnAutoItExit()
	; just to make sure
	If Not ($MULTIINSTANCE) Then _StopAsClipViewer ($hWnd_ME)
EndFunc   ;==>OnAutoItExit

;----------------------------------------------------------
;Save clip board to file.
;----------------------------------------------------------
Func _SaveClipToFile()
	If $DEBUG Then ConsoleWrite("_SaveClipToFile" & @LF)
	Local $clip, $sFile, $outfile, $ret
	;Get the clipboard contents
	If _IsUrl() Then
		If $DEBUG Then ConsoleWrite("_SaveClipToFile>subTo>SaveClipUrlToFile" & @LF)
		Return _SaveClipUrlToFile()
	EndIf
	$clip = ClipGet()
	If Not (@error) Then
		;Get filename
		$sFile = FileSaveDialog("Save Clipboard", $DEFAULT_PATH, $DEFAULT_FILTER, 16, $DEFAULT_EXT)
		If $sFile = "" Then Return 0
		$outfile = FileOpen($sFile, 10)
		If $outfile = -1 Then
			MsgBox(4 + 4096 + 262144, "File Open", "There was an error opening the output file.")
		EndIf
		$ret = FileWrite($outfile, $clip)
		FileClose($outfile)
		$sFile = 0
		If $ret = 0 Then
			MsgBox(4096 + 262144, "File Save", "There was an error saving the file.")
		Else
			;ClipPut("")
			TrayTip("ClipSaver", "File successfully saved.", 10, 0)
			Return 1
		EndIf
		MsgBox(4096 + 262144, "File Save", "Action Canceled.")
	EndIf
EndFunc   ;==>_SaveClipToFile
Func _IsUrl()
	Local $clip = ClipGet()
	If Not (@error) Then
		Local $sLeft = StringLower( StringLeft($clip, 3))
		If $sLeft = "htt" Or $sLeft = "ftp" Then
			Return 1
		EndIf
	EndIf
	Return 0
EndFunc   ;==>_IsUrl
;----------------------------------------------------------
; Returns the Title of the acitve window
; Used for automatic saving action off clipboard
;----------------------------------------------------------
Func _GetActiveWindowTitle($lHwnd)
	;lHwnd should be our handle
	Local $lCurHwnd
	;	Local $sWinText
	;Get the foreground window handle
	$lCurHwnd = DllCall("user32.dll", "hwnd", "GetForegroundWindow")
	If $lCurHwnd = $lHwnd Then Return 0
	$lCurHwnd = $lCurHwnd[0]
	;search for handle in WinList and get title text(for use with other functions)
	Local $aWinList = WinList()
	For $x = 1 To $aWinList[0][0]
		If $aWinList[$x][0] <> "" and (BitAND( WinGetState($aWinList[$x][1]), 2)) Then
			If $lCurHwnd = $aWinList[$x][1] Then
				If $DEBUG Then ConsoleWrite("$aWinList[$x][0]" & $aWinList[$x][0] & @LF)
				;Return the window title.
				Return $aWinList[$x][0]
			EndIf
		EndIf
	Next
	;Not Found.
	Return ""
EndFunc   ;==>_GetActiveWindowTitle
;-------------------------------------------------------------
;Check if beginning of clip is url and try to InetGetSource it
;-------------------------------------------------------------
Func _SaveClipUrlToFile()
	Local $clip = ClipGet()
	If Not (@error) Then
		Local $sLeft = StringLower( StringLeft($clip, 3))
		If $sLeft = "htt" Or $sLeft = "ftp" Then
			Local $sFile = FileSaveDialog("Save Clipboard", $DEFAULT_PATH, $DEFAULT_FILTER, 16, $DEFAULT_EXT)
			
			If Not (@error) Then
				Local $sTmp = InetGet($clip, $sFile)
				If $sTmp = 0 Then
					MsgBox(4096 + 262144, "ClipSaver", "There was an error saving the file.")
					Return 0
				EndIf
				TrayTip("ClipSaver", "File successfully saved.", 10, 0)
				Return 1
			EndIf
		EndIf
	EndIf
	Return 0
EndFunc   ;==>_SaveClipUrlToFile
;----------------------------------------------------------
;Appends data to the clipboard.
;Turns automatic mode off and restores it to former state
;when done.
;----------------------------------------------------------
Func _AppendToClip()
	If $DEBUG Then ConsoleWrite("_AppendToClip" & @LF)
	$sAppendClip = $sAppendClip & @CRLF & ClipGet()
	ClipPut($sAppendClip)
EndFunc   ;==>_AppendToClip
;----------------------------------------------------------
;changes or returns the automatic mode
;----------------------------------------------------------
Func _GetSetAutomaticMode($bMode = -1)
	If $DEBUG Then ConsoleWrite("$bMode=>" & $bMode & @LF)
	Select
		Case $bMode = -3
			if (TrayItemSetState($TrayPaused, $TRAY_ENABLE)) Then
				If $DEBUG Then ConsoleWrite("Auto Enabled" & @LF)
			EndIf
		Case $bMode = -2
			TrayItemSetState($TrayPaused, $TRAY_DISABLE)
		Case $bMode = -1
			;get the value
			Return ($bAUTO * 1)
		Case $bMode = $TRAY_UNCHECKED
			;Pause automatic mode
			If (TrayItemSetState($TrayPaused, $TRAY_UNCHECKED)) Then
				TraySetToolTip("Automatic Mode Off")
				$bAUTO = 0
			EndIf
		Case $bMode = $TRAY_CHECKED
			;Turn automatic mode on
			If (TrayItemSetState($TrayPaused, $TRAY_CHECKED)) Then
				TraySetToolTip("Automatic Mode On")
				$bAUTO = 1
			EndIf
	EndSelect
	If $DEBUG Then ConsoleWrite("$bAUTO>" & $bAUTO & @LF & @LF)
EndFunc   ;==>_GetSetAutomaticMode
;----------------------------------------------------------
;Changes or returns the append mode
;----------------------------------------------------------
Func _SetAppendMode($bMode = -1)
	If $DEBUG Then ConsoleWrite("$bMode=>" & $bMode & @LF)
	Select
		Case $bMode = -1
			;Return the value
			Return $bAPPEND
		Case $bMode = $TRAY_CHECKED
			If $bAUTO_OLD = $NULL Then $bAUTO_OLD = $bAUTO
			If $DEBUG Then ConsoleWrite(">Saved Mode >$bAUTO_OLD>" & $bAUTO_OLD & @LF)
			_GetSetAutomaticMode($TRAY_UNCHECKED)
			_GetSetAutomaticMode(-2)
			;Turn append mode on
			If (TrayItemSetState($TrayAppend, $TRAY_CHECKED)) Then
				$bAPPEND = True
			EndIf
			$sAppendClip = ClipGet()
		Case $bMode = $TRAY_UNCHECKED
			;Stop append mode
			If $sAppendClip <> "" Then
				ClipPut($sAppendClip)
				If MsgBox(4 + 266288, "ClipSaver", "Save Clip to file?") = 6 Then
					_SaveClipToFile()
				EndIf
			EndIf
			;if$bAUTO_OLD <> "" Then
			$bAPPEND = False
			If $DEBUG Then ConsoleWrite(">RestoreMode>$bAUTO_OLD=" & $bAUTO_OLD & @LF)
			_GetSetAutomaticMode(-3)
			Sleep(100)
			_GetSetAutomaticMode($bAUTO_OLD)
			$bAUTO_OLD = $NULL
			;EndIf
			If (TrayItemSetState($TrayAppend, $TRAY_UNCHECKED)) Then
				;TraySetToolTip("Automatic Mode Off")
			EndIf
	EndSelect
	If $DEBUG Then ConsoleWrite("$bAPPEND>" & $bAPPEND & @LF & @LF)
EndFunc   ;==>_SetAppendMode
;----------------------------------------------------------
; Show About screen.
;----------------------------------------------------------
Func _About()
	If Not FileExists(@ScriptDir & "\images\ClipSaver.gif") Then
		Return 0
	EndIf
	Local $Gif1
	Local $hWnd_About = GUICreate("ClipSaver", 340, 260, (@DesktopWidth - 340) / 2, (@DesktopHeight - 260) / 2, -1)
	GUISetIcon(@ScriptDir & "\images\ClipSaver.ico")
	$Gif1 = GUICtrlCreatePic("", 10, 10, 320, 240, BitOR($SS_NOTIFY, $WS_GROUP))
	GUICtrlSetImage($Gif1, @ScriptDir & "\images\ClipSaver.gif")
	GUICtrlCreateLabel("ClipSaver saves clipboard data to a file." & @LF & _
			"Copyright 2006, Stephen Podhajecki" & @LF, 16, 200, 299, 50)
	GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetFont(-1, 12, 250, 2, "Comic Sans MS")
	GUISetState(@SW_SHOW)
	While 1
		Local $nMsg = GUIGetMsg()
		If $nMsg = $GUI_EVENT_CLOSE Then
			GUIDelete($hWnd_About)
			Return 1
		EndIf
		Sleep(10)
	WEnd
	Return 0
EndFunc   ;==>_About